##############################################################################
#
# Copyright (c) 2004 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""
$Id: test_patches.py 655 2005-02-24 17:41:44Z sidnei $
"""

import os, sys

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

# Load fixture
import unittest
from Testing import ZopeTestCase
from Testing.ZopeTestCase import doctest

ZopeTestCase.installProduct('PageTemplates')
ZopeTestCase.installProduct('DavPack')

class FunctionalTest(ZopeTestCase.Functional,
                     ZopeTestCase.ZopeTestCase):
    """A funcional test for PUT behavior"""

def test_suite():
    suite = unittest.TestSuite()
    tests = [
        doctest.FunctionalDocFileSuite('PUT.txt',
                                       package='Products.DavPack.tests',
                                       test_class=FunctionalTest),
        doctest.FunctionalDocFileSuite('PROPPATCH.txt',
                                       package='Products.DavPack.tests',
                                       test_class=FunctionalTest),
        ]
    for t in tests:
        suite.addTest(t)
    return suite

if __name__ == '__main__':
    framework(descriptions=0, verbosity=1)
